package com.fp.persistence.parmas.soli;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMORDENTRABAJOCUSTODIOS*/
@Entity(name="TarmOrdenTrabajoCustodios")
@Table(name="TARMORDENTRABAJOCUSTODIOS")
public class TarmOrdenTrabajoCustodios extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmOrdenTrabajoCustodios
*/
@Id
@Column(name="CORDENTRABAJOCUSTODIOS" ,nullable=false, updatable=false)
@GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SequenceKey", parameters = {
        @Parameter(name = "name", value = "CORDENTRABAJOCUSTODIOS"),//campo secuencial de la tabla
        @Parameter(name = "type", value = "java.lang.Long"),// tipo de dato
        @Parameter(name = "fill", value = "0"),
        @Parameter(name = "length", value = "16")})
@GeneratedValue(generator = "seq_id")
private Long pk;
@Column(name="GRADO", nullable=true)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String grado;

@Column(name="GRADOCODIGO", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String gradocodigo;

@Column(name="CORDENTRABAJO", nullable=true)

/**
* null
*/
private Long cordentrabajo;

@Column(name="CEDULACUSTODIO", nullable=true)

/**
* null
*/
private String cedulacustodio;

@Column(name="NOMBRECUSTODIO", nullable=true)

/**
* null
*/
private String nombrecustodio;

@Column(name="APELLIDOSCUSTIDIO", nullable=true)

/**
* null
*/
private String apellidoscustidio;

@Column(name="OBSERVACIONES", nullable=true)

/**
* null
*/
private String observaciones;

/**Contructor por defecto*/
public TarmOrdenTrabajoCustodios(){
}
/**Contructor de TarmOrdenTrabajoCustodios
@param pPk Clave Primaria del entity
*/
public TarmOrdenTrabajoCustodios(Long pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmOrdenTrabajoCustodios
*/
public static TarmOrdenTrabajoCustodios find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmOrdenTrabajoCustodios obj = pEntityManager.find(TarmOrdenTrabajoCustodios.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmOrdenTrabajoCustodios
@return El objeto que referencia a la Clave primaria de TarmOrdenTrabajoCustodios
*/
public Long getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmOrdenTrabajoCustodios
@param pPk El objeto que referencia a la nueva Clave primaria de TarmOrdenTrabajoCustodios
*/
public void setPk(Long pPk){
  pk=pPk;
}
/**Obtiene el valor de grado
@return valor de grado*/
public String getGrado(){
  return grado;
}
/**Fija el valor de grado
@param pGrado nuevo Valor de grado*/
public void setGrado(String pGrado){
  grado=pGrado;
}

/**Obtiene el valor de gradocodigo
@return valor de gradocodigo*/
public String getGradocodigo(){
  return gradocodigo;
}
/**Fija el valor de gradocodigo
@param pGradocodigo nuevo Valor de gradocodigo*/
public void setGradocodigo(String pGradocodigo){
  gradocodigo=pGradocodigo;
}

/**Obtiene el valor de cordentrabajo
@return valor de cordentrabajo*/
public Long getCordentrabajo(){
  return cordentrabajo;
}
/**Fija el valor de cordentrabajo
@param pCordentrabajo nuevo Valor de cordentrabajo*/
public void setCordentrabajo(Long pCordentrabajo){
  cordentrabajo=pCordentrabajo;
}

/**Obtiene el valor de cedulacustodio
@return valor de cedulacustodio*/
public String getCedulacustodio(){
  return cedulacustodio;
}
/**Fija el valor de cedulacustodio
@param pCedulacustodio nuevo Valor de cedulacustodio*/
public void setCedulacustodio(String pCedulacustodio){
  cedulacustodio=pCedulacustodio;
}

/**Obtiene el valor de nombrecustodio
@return valor de nombrecustodio*/
public String getNombrecustodio(){
  return nombrecustodio;
}
/**Fija el valor de nombrecustodio
@param pNombrecustodio nuevo Valor de nombrecustodio*/
public void setNombrecustodio(String pNombrecustodio){
  nombrecustodio=pNombrecustodio;
}

/**Obtiene el valor de apellidoscustidio
@return valor de apellidoscustidio*/
public String getApellidoscustidio(){
  return apellidoscustidio;
}
/**Fija el valor de apellidoscustidio
@param pApellidoscustidio nuevo Valor de apellidoscustidio*/
public void setApellidoscustidio(String pApellidoscustidio){
  apellidoscustidio=pApellidoscustidio;
}

/**Obtiene el valor de observaciones
@return valor de observaciones*/
public String getObservaciones() {
	return observaciones;
}

/**Fija el valor de observaciones
@param pObservaciones nuevo Valor de observaciones*/
public void setObservaciones(String observaciones) {
	this.observaciones = observaciones;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmOrdenTrabajoCustodios))return false;
    TarmOrdenTrabajoCustodios that = (TarmOrdenTrabajoCustodios) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmOrdenTrabajoCustodios
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmOrdenTrabajoCustodios
*/
public Object createInstance(){
 TarmOrdenTrabajoCustodios instance=new TarmOrdenTrabajoCustodios();	
 return instance;
}
/**Clona la entidad TarmOrdenTrabajoCustodios
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmOrdenTrabajoCustodios p=(TarmOrdenTrabajoCustodios)this.clone();
  return p;
}
}
